infixl 0 <|>


data N = N1 L | N2 L L
  deriving Show


data L = L1 B | L2 L B
  deriving Show


data B = O | I
  deriving Show


-- Datentypen erzeugen

-- N  -> L | L.L
-- L  -> BL'
-- L' -> Epsilon | BL'
-- B  -> 0  | 1

pN :: Parser Char N
pN = 
  pL >>= return . N1
  <|> do
  l1 <- pL 
  pSym '.'
  l2 <- pL
  return (N2 l1 l2)


pL :: Parser Char L
pL = do
  b <- pB 
  l <- pL'
  return (l (L1 b))


pL' :: Parser Char (L -> L)
pL' = 
  return id
  <|> do
  b <- pB 
  l <- pL'
  return (\l' -> l (L2 l' b))


pB :: Parser Char B
pB = do
  pSym '0'
  return O
  <|> do
  pSym '1'
  return I


-- S-Attributierung

pNs :: Parser Char Float
pNs = do
  (v1,l1) <- pLs
  return (v1 * 2 ^ l1) 
  <|> do
  (v1,l1) <- pLs
  pSym '.'
  (v3,_) <- pLs
  return (v1 * 2 ^ l1 + v3)


pLs :: Parser Char (Float, Int)
pLs = do
  v1 <- pBs
  (v2,l2) <- pL's
  return (v1 + 1/2 * v2,l2 + 1)


pL's :: Parser Char (Float, Int)
pL's = 
  return (0,0)
  <|> do
  v1 <- pBs
  (v2,l2) <- pL's
  return (v1 + 1/2 * v2,l2 + 1)


pBs :: Parser Char Float
pBs = do
  pSym '0'
  return 0
  <|> do
  pSym '1'
  return (1/2)


-- L-Attributierung

pNl :: Parser Char Float
pNl = pLl 0


pLl :: Float -> Parser Char Float
pLl d0 = do
  v1 <- pBl 
  pL'l (v1 + d0 * 2)


pL'l :: Float -> Parser Char Float
pL'l d0 =
  return d0 
  <|> do
  v1 <- pBl 
  pL'l (v1 + d0 * 2)


pBl :: Parser Char Float
pBl = do
  pSym '0'
  return 0 
  <|> do
  pSym '1'
  return 1


data Parser s a = Parser ([s] -> [(a,[s])])

instance Monad (Parser s) where
  --(>>=) :: Parser s a -> (a -> Parser s b) -> Parser s b
  Parser p >>= qf = Parser (\ts ->
                            [ res
                            | (pv,ts1) <- p ts,
                              let (Parser q) = qf pv,
                              res <- q ts1])

  return v = Parser (\ts -> [(v,ts)])

pPred :: (s -> Bool) -> Parser s s
pPred pred = Parser (\ts -> case ts of
                              t:ts' -> if pred t
                                         then [(t,ts')]
                                         else []
                              [] -> [])

pSym :: Eq s => s -> Parser s s
pSym x = pPred (x==)

(<|>) :: Parser s a -> Parser s a -> Parser s a
(Parser p) <|> (Parser q) =
       Parser (\input -> p input++q input)

runParser :: Parser s a -> [s] -> [(a,[s])]
runParser (Parser p) ts = p ts

anbn = do
  pSym 'a'
  x <- anbn
  pSym 'c'
  return (x+1)
  <|>
  return 0

