import IOExts


-- b)

quicksort xs = quicksortFL xs []


quicksortFL :: [Int] -> [Int] -> [Int]
quicksortFL [] = id

quicksortFL (x:xs) = 
  let (le, gr) = span (<x) xs
  in
  quicksortFL le . (x:) . quicksortFL gr


-- c)

data Counter = Counter Int

instance Show Counter where
  show (Counter i) = " evaluated in " ++ show i

data EvalTree = Cons String [EvalTreeRef] Counter | Uneval | Demand

type EvalTreeRef = IORef EvalTree


showEvalTreeRef :: EvalTreeRef -> IO (String -> String)
showEvalTreeRef r = do
  val <- readIORef r
  xs <- showEvalTree val
  return xs

showEvalTree :: EvalTree -> IO (String -> String)
showEvalTree (Cons  cons [] c) = 
  return (showChar '(' . showString cons . shows c . showChar ')')

showEvalTree (Cons "->" ts c) = do
  args <- mapM showEvalTreeRef ts
  case args of
    [aa,ab,nextFuns] -> 
      return (showChar '(' . aa . showString " -> " . ab . showChar ')' . 
              if nextFuns [] == "_" then id else showChar '\n' . nextFuns)
    [aa,ab] -> return (showChar '(' . aa . showString " -> " . ab 
                      . showChar ')')
showEvalTree (Cons "(,)" ts c) = do
  [aa,ab] <- mapM showEvalTreeRef ts
  return (showChar '(' . aa . showChar ',' . shows c . showChar ')')
showEvalTree (Cons "(,,)" ts c) = do
  [aa,ab,ac] <- mapM showEvalTreeRef ts
  return (showChar '(' . aa . showChar ',' . shows c . ab .
                       showChar ',' . shows c . ac . showChar ')')
showEvalTree (Cons "(:)" ts c) = do
  [aa,ab] <- mapM showEvalTreeRef ts
  return (showChar '(' . aa . showChar ':' . shows c . ab . showChar ')')
showEvalTree (Cons cons ts c) = do
  args <- mapM showEvalTreeRef ts
  return (showChar '(' . 
          foldr (\ x y -> x . showChar ' ' . y) id
                (showString cons:shows c:args) . showChar ')')
                   
showEvalTree Uneval = return (showChar '_')
showEvalTree Demand = return (showChar '!')
